; Scheme 9 from Empty Space, Function Library
; By Nils M Holm, 2010
; See the LICENSE file of the S9fES package for terms of use
;
; (pop! <variable>)          ==>  object
; (push! object <variable>)  ==>  unspecific
;
; PUSH! conses OBJECT to the list bound to <variable>,
; and updates the value of <variable> to the new list.
;
; POP! removes the first element of the list bound to
; <variable> and updates <variable> to the rest of that
; list. It returns the element removed from the list.
;
; Example:   (let ((stack (list 0 2 3 4)))
;              (let ((x (pop! stack)))
;                (push! 1 stack)
;                (list x stack)))           ==>  (0 (1 2 3 4))

(define-syntax (push! obj var)
  `(set! ,var (cons ,obj ,var)))

(define-syntax (pop! var)
  (let ((top (gensym)))
    `(let ((,top (car ,var)))
       (set! ,var (cdr ,var))
       ,top)))
